// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### FlowLabel Beispiel: Client                                       ####
// ####                                                                  ####
// #### Version 1.00  --  May 18, 2000                                   ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://titan.cs.uni-bonn.de/~dreibhol ####
// ####                                                                  ####
// ##########################################################################


#include <netdb.h>
#include <linux/in6.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>


#define SOL_IPV6                41
#define IPV6_FLOWINFO_FLOWLABEL 0x000fffff
#define IPV6_FLOWINFO_PRIORITY  0x0ff00000


int main()
{
    hostent* hostInfo = gethostbyname2("3ffe:815:4711::111",AF_INET6);
    if(hostInfo == NULL) exit(1);

    // ====== Socket erstellen ==============================================
    sockaddr_in6 adr;
    adr.sin6_port     = htons(7466);
    adr.sin6_family   = AF_INET6;
    adr.sin6_flowinfo = 0;
    memcpy((void*)&adr.sin6_addr,(void*)hostInfo->h_addr_list[0],hostInfo->h_length);
    int sd = socket(AF_INET6,SOCK_DGRAM,0);
    if(sd != -1) {   
       struct in6_flowlabel_req req;
       memcpy((void*)&req.flr_dst  ,(void*)&adr.sin6_addr,16);

      
       // ====== Label reservieren ==========================================
       req.flr_label   = 0;
       req.flr_action  = IPV6_FL_A_GET;
       req.flr_share   = IPV6_FL_S_USER;
       req.flr_flags   = IPV6_FL_F_CREATE;
       req.flr_expires = 3;
       req.flr_linger  = 6;
       req.__flr_pad   = 0;
       int i = setsockopt(sd,SOL_IPV6,IPV6_FLOWLABEL_MGR,&req,sizeof(in6_flowlabel_req));
       if(i != 0) {
          puts("FEHLER: Label konnte nicht reserviert werden!");
          exit(1);
       }
       printf("FlowLabel = %05x\n",ntohl(req.flr_label));


       // ====== Label-Reservierung aktualisieren ===========================
       req.flr_action  = IPV6_FL_A_RENEW;
       req.flr_expires = 30;
       req.flr_linger  = 6;
       req.__flr_pad   = 0;
       i = setsockopt(sd,SOL_IPV6,IPV6_FLOWLABEL_MGR,&req,sizeof(in6_flowlabel_req));
       if(i != 0) {
          puts("FEHLER: Label-Reservierung konnte nicht erneuert werden!");
          exit(1);
       }


       // ====== Socket fr FlowLabel-Verwendung einstellen =================
       int x = 1;
       i = setsockopt(sd,SOL_IPV6,IPV6_FLOWINFO_SEND,&x,4);
       if(i != 0) {
          puts("FEHLER: Socket nicht fr Label-Verwendung einstellbar!");
          exit(1);
       }

       // ====== Verbinden mit Server =======================================
       adr.sin6_port     = htons(7466);
       adr.sin6_family   = AF_INET6;
       adr.sin6_flowinfo = req.flr_label;    // keine Adresse, nur Flow-Label
       memset((void*)&adr.sin6_addr,0,16);
       i = connect(sd,(sockaddr*)&adr,sizeof(sockaddr_in6));
       if(i != 0) {
          puts("FEHLER: Keine Verbindung zum Server herstellbar!");
          exit(0);
       }
       
       char str[64];
       strcpy((char*)&str,"Hello World!");
       i = write(sd,(void*)&str,15);
       if(i != 15) {
          puts("FEHLER: write()-Fehler!");
       }
       else {
          puts("Nachricht gesendet!");
       }   
    }
    else {
       puts("FEHLER: Socket kann nicht erstellt werden!");
       exit(0);
    }

   return(0);
}