// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Media Info                                                       ####
// ####                                                                  ####
// #### Version 1.00  --  February 23, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


/**
  * This class contains information on a media.
  *
  * @short   Media Info
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
  */
class MediaInfo
{
   // ====== Constructor ====================================================
   MediaInfo() {
      reset();
   }


   // ====== Reset ==========================================================
   void reset() {
      StartTimeStamp = 0;
      EndTimeStamp   = 0;
      Title          = "";
      Artist         = "";
      Comment        = "";
   }


   // ====== MediaInfo data =================================================
   /**
     * Start time stamp of the media.
     */
   long StartTimeStamp;

   /**
     * End time stamp of the media.
     */
   long EndTimeStamp;

   /**
     * Title string.
     */
   String Title;

   /**
     * Artist string.
     */
   String Artist;

   /**
     * Comment string.
     */
   String Comment;
};

