#ifndef FUTUREEVENTLIST_H
#define FUTUREEVENTLIST_H

#include "synchronizable.h"
#include "events.h"
#include <queue>
#include <fstream>
#include "strings.h"
#include "mytools.h"

namespace Coral {

union FELElement {
  Event  event;
  double doubleArg;
  int    intArg;
};

class FutureEventList : Synchronizable {
 public:
  FutureEventList();
  void push(FELElement elem);
  FELElement pop();
  bool empty();
  void readInputFile(char* filename);
  queue<FELElement> eventQueue;
};

}
#endif
