#ifndef LEVEL_H
#define LEVEL_H

#include "layer.h"
#include <vector>

namespace Coral {

class LayeredStream;

class Level {
 public:
  Level(LayeredStream* stream_);

  ~Level();

  void      setLevelUp(card8 up);
  card8     getLevelUp();

  void      setLevelDown(card8 down);
  card8     getLevelDown();

  void      setQuality(card8 qual);
  card8     getQuality();

  void      setDelay(card32 delay);
  card32    getDelay();

  void      setFPSScale(double scale);
  double    getFPSScale();
  card32    getFPS();

  void      addLayer(Layer* l);
  Layer*    getLayer(int index);

  card8     getNumLayers();

  bool      findClasses();

  bool      classOk(card8 class_);

  LayeredStream* getStream();
  void      setStream(LayeredStream* stream_);

  card64    getBandwidth();

 private:
  LayeredStream* stream;

  card8  levelUp;

  card8  levelDown;

  card8  quality;

  card32 maxTransferDelay;

  double fps_scale;

  vector<Layer*> layer;
};

}

#include "level.icc"

#endif
