// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Audio Encoder Interface                                          ####
// ####                                                                  ####
// #### Version 1.00  --  February 23, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#ifndef AUDIOENCODERINTERFACE_H
#define AUDIOENCODERINTERFACE_H


#include "system.h"
#include "encoderinterface.h"
#include "audioqualityinterface.h"


namespace Coral {


/**
  * This class is the interface for an audio encoder.
  *
  * @short   Audio Encoder Interface
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
  */
class AudioEncoderInterface : virtual public EncoderInterface,
                              virtual public AdjustableAudioQualityInterface
{
};


}


#endif
