package bonn.infoIV.v3d2.buffer;

import java.util.Vector;

/**
 */
public class SyncBuffer
{
  public static final int OBJECT = 0; // The only object, because we currently animate only 1 3D-object

  protected Vector BufferedObjects_ = null;
  protected Vector StreamIds_       = null;

  protected int    BiggestArraySize_ = 0;

  private DoubleBufferedObject Obj_ = null;

  public SyncBuffer()
  {
    super();
    BufferedObjects_ = new Vector(10);
    StreamIds_       = new Vector(10);
    StreamIds_.addElement(new Integer(OBJECT));
    BufferedObjects_.addElement(new Object3D(SyncBuffer3D.SIZE_COUNT, SyncBuffer3D.ARRAY_COUNT, OBJECT));
  }


  public void putToArray(byte array, boolean frame, byte[] data, boolean resetOffset, int newSize, int id, int maxInPacket)
  {
    Obj_ = (DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))));
    Obj_.setArray(array, frame, data, resetOffset, newSize, maxInPacket);
  }


  public int getBiggestArraySize() { return BiggestArraySize_; }


  public void setStatus(boolean array, int id)
  {
    ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).setStatus(array);
  }

  public boolean getStatus(boolean array, int id)
  {
    return ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).getStatus(array);
  }


  public int getReceivedSplitCount(int id, boolean frame)
  {
    Obj_ = (DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))));
    return (Obj_.getReceivedSplitCount(frame)/Object3D.SPLIT_ENTITY);  // UNSCHOEN
  }




  /**
   * This gives you access to a specific Array. Before calling this method one MUST verify with isReadable, 
   * if the Object with id==identifier is readable or Not. MAYBE this will be handled by an Event later. 
   * This Method only provides a reference, not a real copy of the byte-array
   *
   * @param arrayId - the specific array you want to get. Specified in SynBuffer3D, or other subclasses.
   * @param fillMe  - The reference, where the specific array reference will be written to
   * @param id      - The id of the Object, from which the array is. 
   */
  public void get(byte arrayId, int id, byte[] fillMe)
  {
    fillMe = ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).Arrays_[arrayId];
  }//sd

  public byte[] get(byte arrayId, int id)
  {
    return ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).Arrays_[arrayId];
  }//sd

  public void resetArray(byte arrayId, int id, int length)
  {
    ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).resetArray(arrayId, length);
  }

  public int[] getInfo(boolean frame, int id)
  {
    return ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).getInfo(frame);
  }

  public void setInfo(boolean frame, int id, int[] newInfo)
  {
    ((DoubleBufferedObject)(BufferedObjects_.elementAt(StreamIds_.indexOf(new Integer(id))))).setInfo(frame, newInfo);
  }
}

