package bonn.infoIV.v3d2.rtp;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.InetAddress;
import java.net.SocketException;

public class ControlChannel3D extends UDPControlChannel
{
  protected int FrameCounter_ = 0;

  public ControlChannel3D(InetAddress destAddress, int destPort, int port, DataChannel dc) throws SocketException
  {
    super(destAddress, destPort, port, dc);
  }


  public void processPacket(DataInputStream in)
  {
    RTCPPacket_.readPacket(in);

    System.out.println("+++++++++++++++++++++++++++++++++");
    switch(RTCPPacket_.getHeader().getRTPVersion())
    {
      case RTCPHeader.RTP_VERSION_2:
        System.out.print("RTPVersion 2");
        break;
      case RTCPHeader.RTP_VERSION_1:
        System.out.print("RTPVersion 1");  
        break;
      case RTCPHeader.RTP_VERSION_0:
        System.out.print("RTPVersion 0");
        break;
      default:
        break;
    }

    System.out.print(" :Padding:" +RTCPPacket_.getHeader().getPadding());
    System.out.print(" :RC:" +RTCPPacket_.getHeader().getReceiverCount());

    switch(RTCPPacket_.getHeader().getPayloadType())
    {
      case RTCPHeader.PAYLOAD_TYPE_SR:
        System.out.print(" :PT - SR");
        break;
      case RTCPHeader.PAYLOAD_TYPE_RR:
        System.out.print(" :PT - RR");  
        break;
      case RTCPHeader.PAYLOAD_TYPE_SDES:
        System.out.print(" :PT - SDES");
        break;
      case RTCPHeader.PAYLOAD_TYPE_BYE:
        System.out.print(" :PT - BYE");
        break;
      case RTCPHeader.PAYLOAD_TYPE_APP:
        System.out.print(" :PT - APP");
        break;
      default:
        break;
    }

    System.out.print(" :Length: " +RTCPPacket_.getHeader().getLength());
    System.out.println(" :SSRC: " +RTCPPacket_.getHeader().getSSRC());
    if(RTCPPacket_.getHeader().getPayloadType()==RTCPHeader.PAYLOAD_TYPE_RR)
    {
      RTCPReportBlock block = RTCPPacket_.getReportBlocks()[0];
      System.out.println("----------------------------------");
      System.out.print("RB: SSRC: " +block.getSSRC());
      System.out.print(" : FractionLost: " +(float)block.getLostFraction());
      System.out.print(" : PacketsLost: " +block.getLostPackets());
      System.out.print(" : HighSeqNum: " +block.getHighestSeqNumber());
      System.out.print(" : Jitter: " +block.getInterarrivalJitter());
      System.out.print(" : LSR: " +block.getLSR());
      System.out.println(" : DLSR: " +block.getDLSR());
    }
  }


  public void createPacket(DataOutputStream out) {}

}
