package bonn.infoIV.v3d2.rtp;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.EOFException;

public class RTPPacket
{
  public static final int MAX_PAYLOAD_SIZE = 1024;  // [PENDING] Die Groesse von payload  sollte im Header stehen
  public static final int PM_INFO_PL_SIZE       = 0;
  public static final int BASE_VERTEX_PL_SIZE   = 0;
  public static final int BASE_TRIANGLE_PL_SIZE = 0;
  public static final int VERTEX_SPLITS_PL_SIZE = 0;

  protected RTPHeader MyHeader_    = null;
  protected byte[]    PayloadData_ = null;

  public RTPPacket()
  {
    super();
    MyHeader_ = new RTPHeader();
    PayloadData_ = new byte[MAX_PAYLOAD_SIZE];
  }

  public void readPacket(DataInputStream in)
  {
    try
    {
      MyHeader_.readHeader(in);
      in.readFully(PayloadData_);
    }
    catch(Exception e)
    {
      if(e instanceof EOFException)
      {
        System.err.println("[ERROR] EOFExeption while reading RTPPacket: " +e.getMessage());
      }
      else System.err.println("[ERROR] reading RTPPacket: " +e.getMessage());
    }
  }


  public void writePacket(DataOutputStream out)
  {
    try
    {
      MyHeader_.writeHeader(out);
      out.write(PayloadData_);
      out.flush();
    }
    catch(IOException e) { System.err.println("[ERROR] writing RTPPacket: " +e.getMessage()); }
  }


  public void setHeader(RTPHeader h) { MyHeader_ = h; }
  public RTPHeader getHeader() { return MyHeader_; }

  public void setPayloadData(byte[] data) { PayloadData_ = data; }
  public byte[] getPayloadData() { return PayloadData_; }

  public int getPayloadSize()
  {
    return PayloadData_.length; // Dies wird bei schwankenden groessen nicht ausreichen
  }
}










