package bonn.infoIV.v3d2.rtp;

import bonn.infoIV.v3d2.buffer.SyncBuffer;
import java.net.InetAddress;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.SocketException;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;

public abstract class UDPDataChannel extends DataChannel
{
  public final byte ChannelType_ = UDP_CHANNEL;

  protected DatagramSocket Socket_  = null;

  public UDPDataChannel(InetAddress dest, int destPort, int port, SyncBuffer ref) throws SocketException
  {
    super(ref);

    Socket_ = new DatagramSocket(port);
    Socket_.connect(dest, destPort);
    Socket_.setReceiveBufferSize(RTPPacket.MAX_PAYLOAD_SIZE*BUFFER_SIZE);
    Socket_.setSendBufferSize(RTPPacket.MAX_PAYLOAD_SIZE*2);
  }


  public void receive()
  {
    DatagramPacket packet = null;
    try
    {
      // Java 1.2.2 rc 3: getReceiveBufferSize() delivers always -1! therfore we workarount
      //packet = new DatagramPacket(new byte[Socket_.getReceiveBufferSize()], Socket_.getReceiveBufferSize());
      packet = new DatagramPacket(new byte[RTPPacket.MAX_PAYLOAD_SIZE*BUFFER_SIZE], RTPPacket.MAX_PAYLOAD_SIZE*BUFFER_SIZE);
      Socket_.receive(packet);
    }
    catch(IOException e)
    {
/* TD: Ich habe das hier einfach auskommentiert. Die Exception tritt auf,
       wenn der Prog4D-Client durch MainControl beendet wird.
       
      System.err.println("[Error]: IO receiving DatagramPacket: " +e.getMessage());
      System.err.println("Der Stacktrace: ");
      e.printStackTrace();
      System.exit(0);
      //if (e.getMessage()=="null") return;
*/
      return;
    }
    processPacket(new DataInputStream(new ByteArrayInputStream(packet.getData())));
  }


  public void send(RTPPacket packet)
  {}

  public void shutdown()
  {
    super.shutdown();
    Socket_.close();
  }

}





