package mpi_graphics;

import javax.media.j3d.ColoringAttributes;

public class Closed_Oriented_Mesh_Geometry extends Oriented_Mesh_Geometry
{
    // Variablen fuer add_vertex
    private int[] split_index = new int[3];
    private int[] v_array = new int[3];
    private float[] n_f= new float[3];
    
// ************************************************************************************
// Closed_Oriented_Mesh_Geometry
// ************************************************************************************
    public Closed_Oriented_Mesh_Geometry(Mesh_Info info, Mesh_Info base_info, int shade_modus)
    {
	super(info,base_info,shade_modus);
    }
        
// ************************************************************************************
// add_vertex
// ************************************************************************************
  final public boolean add_vertex(int i_vertex_split, Mesh_Geometry_Array mesh_array) throws Exception
  {
    int vertex,start_vertex,end_vertex;
    int act_triangle,next_triangle;
    int outer_triangle;
    int start_pos;
    int act_pos_1,act_pos_2;
    // performance
    int dummy_pos;
    int to_do_pos_start;
    int to_do_pos_end;

    //test
    //check_position_cache(num_triangles_act);
    // Uberpruefe Ergebnis
    //int i;
    //for (i=0;i<num_vertices_act;i++)
    //{
    //valenz_new(i);
    //valenz(i);
    //}
    //Global.Error_Occured("Test!!!");
    
    mesh_array.get_vertex_split_indices(i_vertex_split,split_index);
    //System.out.println("Add Vertex " + (num_vertices_base+vertex_split_number));
    
    //if (num_vertices_act==num_vertices_max)
    //Global.Error_Occured("Anzahl der Vertices wird groesser als erlaubt!!!");
    
    //Lese Vertexinfo
    vertex=split_index[0];
    start_vertex=split_index[2];
    end_vertex=split_index[1];

    //System.out.println("Die Valenz von Vertex " + vertex + " ist " + valenz(vertex));
    //System.out.println("Vertex-Split " + start_vertex + " " +  end_vertex);
    if (vertex<0) Global.Error_Occured("Mittlerer Vertex ist < 0!!!");

    if (vertex>=num_vertices_act || start_vertex>=num_vertices_act || end_vertex>=num_vertices_act)
      Global.Error_Occured("Ein Vertex im Vertex-Split Eintrag ist zu gross!!!");

    if (start_vertex>=0 && end_vertex>=0)
    {
      act_triangle=search_triangle_using_orientation(vertex,start_vertex);
      if (act_triangle == -1) return false;
      start_pos=act_triangle>>>30;
      act_triangle=act_triangle&POS_BLEND;

      act_pos_1=(start_pos+1)%3;
      act_pos_2=(start_pos+2)%3;
      next_triangle=triangle_neighbor_array[act_triangle][act_pos_1];
      outer_triangle=triangle_neighbor_array[act_triangle][act_pos_2];

      // 1. neues Dreieck
      get_vertex_indices(act_triangle,v_array);
      v_array[act_pos_2]=num_vertices_act;
      set_vertex_indices(num_triangles_act,v_array);
      triangle_neighbor_array[num_triangles_act][start_pos]=act_triangle;
      triangle_neighbor_array[num_triangles_act][act_pos_1]=num_triangles_act+1;
      triangle_neighbor_array[num_triangles_act][act_pos_2]=outer_triangle;
      pos_cache[num_triangles_act][start_pos]=(byte)act_pos_1;
      to_do_pos_start=act_pos_1;  // to do
      pos_cache[num_triangles_act][act_pos_2]=pos_cache[act_triangle][act_pos_2];
      
      set_vertex_index(act_triangle,start_pos,num_vertices_act);
      triangle_neighbor_array[act_triangle][act_pos_2]=num_triangles_act;	
      pos_cache[act_triangle][act_pos_2]=(byte)act_pos_2;

      if (outer_triangle==NO_TRIANGLE)
      {
	//System.out.println("Am Rand_1!!!");
	//Global.Error_Occured("Die verwendete Struktur ist nicht fuer Offene Meshes geeignet!!!");
      }
      else
      {
	dummy_pos=(pos_cache[num_triangles_act][act_pos_2]+1)%3;
	triangle_neighbor_array[outer_triangle][dummy_pos]=num_triangles_act;
	pos_cache[outer_triangle][dummy_pos]=(byte)act_pos_1;
      }

      while(get_vertex_index(act_triangle,(act_pos_1+1)%3)!=end_vertex)
      {
	//if (next_triangle==NO_TRIANGLE)
	//Global.Error_Occured("Unmoeglicher Zustand in add_vertex!!!");
	    
	act_pos_1=pos_cache[act_triangle][act_pos_1];
	act_triangle=next_triangle;
	next_triangle=triangle_neighbor_array[act_triangle][act_pos_1];

	//System.out.println(vertex);
	set_vertex_index(act_triangle,(act_pos_1+2)%3,num_vertices_act);	
      }

      // 2. neues Dreieck
      start_pos=(act_pos_1+2)%3;
      act_pos_2=(act_pos_1+1)%3;

      outer_triangle=triangle_neighbor_array[act_triangle][act_pos_1];
      
      get_vertex_indices(act_triangle,v_array);
      v_array[start_pos]=vertex;
      v_array[act_pos_1]=num_vertices_act;
      set_vertex_indices(num_triangles_act+1,v_array);
      triangle_neighbor_array[num_triangles_act+1][start_pos]=act_triangle;
      triangle_neighbor_array[num_triangles_act+1][act_pos_1]=outer_triangle;
      triangle_neighbor_array[num_triangles_act+1][act_pos_2]=num_triangles_act;
      pos_cache[num_triangles_act+1][start_pos]=(byte)start_pos;
      pos_cache[num_triangles_act+1][act_pos_1]=pos_cache[act_triangle][act_pos_1];
      to_do_pos_end=act_pos_2;  // to do
      
      triangle_neighbor_array[act_triangle][act_pos_1]=num_triangles_act+1;
      pos_cache[act_triangle][act_pos_1]=(byte)act_pos_2;

      if (outer_triangle==NO_TRIANGLE)
      {
	//System.out.println("Am Rand_2!!!");
      }
      else
      {
	dummy_pos=(pos_cache[num_triangles_act+1][act_pos_1]+1)%3;
	triangle_neighbor_array[outer_triangle][dummy_pos]=num_triangles_act+1;
	pos_cache[outer_triangle][dummy_pos]=(byte)start_pos;
      }
	
      // to do pos
      pos_cache[num_triangles_act][to_do_pos_start]=(byte)((to_do_pos_end+2)%3);
      pos_cache[num_triangles_act+1][to_do_pos_end]=(byte)((to_do_pos_start+2)%3);

      // test
      start_pos=(to_do_pos_start+2)%3;
      start_triangle_list[vertex]=num_triangles_act|(start_pos<<30);
      start_pos=(to_do_pos_start+1)%3;
      start_triangle_list[num_vertices_act]=num_triangles_act|(start_pos<<30);
      
      num_vertices_act++;
      num_triangles_act=num_triangles_act+2;
    }
    else 
      if (start_vertex<0) Global.Error_Occured("Erster Vertex ist < 0!!!");
      else
	// ************************************************************************************
	// 2. Vertex
	// ************************************************************************************
	if (end_vertex<0)
	{
	  //System.out.println("Fuege Randvertex ein: " + vertex + " " + start_vertex);
	  act_triangle=search_triangle_using_orientation(vertex,start_vertex);
	  if (act_triangle == -1) return false;
	  start_pos=act_triangle>>>30;
	  act_triangle=act_triangle&POS_BLEND;
	  
	  act_pos_1=(start_pos+1)%3;
	  act_pos_2=(start_pos+2)%3;
	  next_triangle=triangle_neighbor_array[act_triangle][act_pos_1];
	  outer_triangle=triangle_neighbor_array[act_triangle][act_pos_2];

	  // 1. neues Dreieck
	  get_vertex_indices(act_triangle,v_array);
	  v_array[act_pos_2]=num_vertices_act;
	  set_vertex_indices(num_triangles_act,v_array);
	  triangle_neighbor_array[num_triangles_act][start_pos]=act_triangle;
	  triangle_neighbor_array[num_triangles_act][act_pos_1]=NO_TRIANGLE;
	  triangle_neighbor_array[num_triangles_act][act_pos_2]=outer_triangle;
	  pos_cache[num_triangles_act][start_pos]=(byte)act_pos_1;
	  to_do_pos_start=act_pos_1;  // to do
	  pos_cache[num_triangles_act][act_pos_2]=pos_cache[act_triangle][act_pos_2];
	  
	  set_vertex_index(act_triangle,start_pos,num_vertices_act);
	  triangle_neighbor_array[act_triangle][act_pos_2]=num_triangles_act;	
	  pos_cache[act_triangle][act_pos_2]=(byte)act_pos_2;

	  if (outer_triangle==NO_TRIANGLE)
	  {
	    //System.out.println("Am Rand_1!!!");
	    //Global.Error_Occured("Die verwendete Struktur ist nicht fuer Offene Meshes geeignet!!!");
	  }
	  else
	  {
	    dummy_pos=(pos_cache[num_triangles_act][act_pos_2]+1)%3;
	    triangle_neighbor_array[outer_triangle][dummy_pos]=num_triangles_act;
	    pos_cache[outer_triangle][dummy_pos]=(byte)act_pos_1;
	  }

	  while(next_triangle!=NO_TRIANGLE)
	  {
	    //if (next_triangle==NO_TRIANGLE)
	    //Global.Error_Occured("Unmoeglicher Zustand in add_vertex!!!");
	    
	    act_pos_1=pos_cache[act_triangle][act_pos_1];
	    act_triangle=next_triangle;
	    next_triangle=triangle_neighbor_array[act_triangle][act_pos_1];

	    //System.out.println(vertex);
	    set_vertex_index(act_triangle,(act_pos_1+2)%3,num_vertices_act);	
	  }

	  // test
	  start_pos=(to_do_pos_start+2)%3;
	  start_triangle_list[vertex]=num_triangles_act|(start_pos<<30);
	  start_pos=(to_do_pos_start+1)%3;
	  start_triangle_list[num_vertices_act]=num_triangles_act|(start_pos<<30);

	  num_vertices_act++;
	  num_triangles_act++;

	  //valenz_new(num_vertices_act-1);
	}
	else
	  Global.Error_Occured("Unmoeglicher Zustand!");
	
    // Uberpruefe Ergebnis
    //int i;
    //for (i=0;i<num_vertices_act;i++)
    //{
    //valenz_new(i);
    //valenz(i);
    //}
    //Global.Error_Occured("Test!!!");
    
    //System.out.println("Die Valenz von Vertex " + vertex + " ist " + valenz(vertex));
    //System.out.println("Die Valenz von Vertex " + (num_vertices_act-1) + " ist " + valenz(num_vertices_act-1));
    return true;
  }

// ************************************************************************************
// search_triangle_using_orientation
// ************************************************************************************
    final public int search_triangle_using_orientation(int v1, int v2)
    {
	int act_triangle_number;
	int old_triangle_number;
	int act_pos_1;
	int start_act_pos_1;
	int start_triangle_number;
	int v_next;

	start_triangle_number=start_triangle_list[v1];
	start_act_pos_1=((start_triangle_number>>>30)+1)%3;
	start_triangle_number=start_triangle_number&POS_BLEND;
	act_triangle_number=start_triangle_number;
	act_pos_1=start_act_pos_1;
	//System.out.println("NEU_____________________________________");
	// Suche vorwaerts
	do
	{
	    v_next=get_vertex_index(act_triangle_number,act_pos_1);
	    if (v_next==v2)
	      {
		//System.out.println("v_next in Erster while-schleife gefunden");
		return(act_triangle_number | (((act_pos_1+2)%3)<<30));
	      }
	    
	    old_triangle_number=act_triangle_number;
	    act_triangle_number=triangle_neighbor_array[act_triangle_number][act_pos_1];
	    act_pos_1=pos_cache[old_triangle_number][act_pos_1];
	    //System.out.println("Die act_triangle_number ist : " +act_triangle_number);
	    if(start_triangle_number==act_triangle_number) return -1;
	    //if (act_triangle_number==start_triangle_number)
		//Global.Error_Occured("Unmoeglicher Zustand!");
	}
	while (act_triangle_number!=NO_TRIANGLE);
	//while (act_triangle_number!=start_triangle_number && act_triangle_number!=NO_TRIANGLE);
        //System.out.print("Erste do-while NIX...");
	
	act_triangle_number=start_triangle_number;
	act_pos_1=start_act_pos_1;
	
	// Suche rueckwaerts
	do
	{
	    old_triangle_number=act_triangle_number;
	    act_triangle_number=triangle_neighbor_array[act_triangle_number][(act_pos_1+1)%3];
	    act_pos_1=(pos_cache[old_triangle_number][(act_pos_1+1)%3]+1)%3;

	    v_next=get_vertex_index(act_triangle_number,act_pos_1);
	    if (v_next==v2)
	      {
		//System.out.println("v_next in Zweiter while-schleife gefunden");
		return(act_triangle_number | (((act_pos_1+2)%3)<<30));
	      }
	    if(start_triangle_number==act_triangle_number) return -1;
	}
	while (true);
    } 
    
// ************************************************************************************
// update_normals
// ************************************************************************************
    final public void update_normals(int start, int end)
    {
	int i;
	
	if (shade_modus==ColoringAttributes.SHADE_GOURAUD)
	{
	    for (i=start;i<end;i++)
		update_normal_triangle_for_gourand(i);
		
	    for (i=start;i<end;i++)
	    {
		transform_triangle_to_vertex_normal(i);
	    }
	    
	    set_normals(n_f_afterburner_vertex);
	}
	else
	{
	    for (i=start;i<end;i++)
		update_normal_triangle(i);
	}
    }                          

// ************************************************************************************
// update_normal_triangle
// ************************************************************************************
    final public void update_normal_triangle(int vertex)
    {
	int act_triangle_number;
	int old_triangle_number;
	int act_pos_1;
	int start_act_pos_1;
	int start_triangle_number;

	// Macht die Vertexnummer Sinn?
	if (vertex>=num_vertices_act)
		Global.Error_Occured("Die Normalen koennen nicht upgedated werden!!!");

	start_triangle_number=start_triangle_list[vertex];
	start_act_pos_1=((start_triangle_number>>>30)+1)%3;
	start_triangle_number=start_triangle_number&POS_BLEND;
	act_triangle_number=start_triangle_number;
	act_pos_1=start_act_pos_1;

	// Suche vorwaerts
	do
	{
	    calculate_triangle_normal(act_triangle_number,n_f);
	    set_normal(act_triangle_number,n_f);
	    
	    old_triangle_number=act_triangle_number;
	    act_triangle_number=triangle_neighbor_array[act_triangle_number][act_pos_1];
	    act_pos_1=pos_cache[old_triangle_number][act_pos_1];

	    if (act_triangle_number==start_triangle_number)
		return;
	}
	while (act_triangle_number!=NO_TRIANGLE);
	    
	act_triangle_number=start_triangle_number;
	act_pos_1=start_act_pos_1;
	
	// Suche rueckwaerts
	do
	{
	    old_triangle_number=act_triangle_number;
	    act_triangle_number=triangle_neighbor_array[act_triangle_number][(act_pos_1+1)%3];
	    act_pos_1=(pos_cache[old_triangle_number][(act_pos_1+1)%3]+1)%3;

	    if (act_triangle_number==NO_TRIANGLE)
		return;

	    calculate_triangle_normal(act_triangle_number,n_f);
	    set_normal(act_triangle_number,n_f);
	}
	while (true);
    }                          

// ************************************************************************************
// update_normal_triangle_for_gourand
// ************************************************************************************
    final public void update_normal_triangle_for_gourand(int vertex)
    {
	int act_triangle_number;
	int old_triangle_number;
	int act_pos_1;
	int start_act_pos_1;
	int start_triangle_number;

	// Macht die Vertexnummer Sinn?
	if (vertex>=num_vertices_act)
		Global.Error_Occured("Die Normalen koennen nicht upgedated werden!!!");

	start_triangle_number=start_triangle_list[vertex];
	start_act_pos_1=((start_triangle_number>>>30)+1)%3;
	start_triangle_number=start_triangle_number&POS_BLEND;
	act_triangle_number=start_triangle_number;
	act_pos_1=start_act_pos_1;

	// Suche vorwaerts
	do
	{
	    calculate_triangle_normal_for_gourand(act_triangle_number);
	    
	    old_triangle_number=act_triangle_number;
	    act_triangle_number=triangle_neighbor_array[act_triangle_number][act_pos_1];
	    act_pos_1=pos_cache[old_triangle_number][act_pos_1];

	    if (act_triangle_number==start_triangle_number)
		return;
	}
	while (act_triangle_number!=NO_TRIANGLE);
	    
	act_triangle_number=start_triangle_number;
	act_pos_1=start_act_pos_1;
	
	// Suche rueckwaerts
	do
	{
	    old_triangle_number=act_triangle_number;
	    act_triangle_number=triangle_neighbor_array[act_triangle_number][(act_pos_1+1)%3];
	    act_pos_1=(pos_cache[old_triangle_number][(act_pos_1+1)%3]+1)%3;

	    if (act_triangle_number==NO_TRIANGLE)
		return;

	    calculate_triangle_normal_for_gourand(act_triangle_number);
	}
	while (true);
    }                          
}
