// socket.hh --- Socket Class Header File

#ifndef SOCKET_H
#define SOCKET_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/uio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>

class Socket
{
private:
  int sd;
  int domain;
  int type;
  int protocol;
  int backlog;
  unsigned int send_flags;
  unsigned int recv_flags;
public:
  Socket();
  int create(int = PF_INET, int = SOCK_DGRAM, int = 0);
  int assignName(struct sockaddr *, int);
  int makeListening(int = 5);
  int acceptConnection(struct sockaddr *, unsigned int *);
  int initConnection(struct sockaddr *, int);
  void setTrafficClass(int trafficClass);
  int sent(void *, int, unsigned int = 0, struct sockaddr * = NULL, int = 0);
  int recw(void *, int, unsigned int = 0, struct sockaddr * = NULL, unsigned int * = NULL);
  int selectRead(struct timeval * = NULL);
  int selectWrite(struct timeval * = NULL);
  int selectExcept(struct timeval * = NULL);
};

#endif
