// time.hh --- Time Class Header File

#ifndef TIME_H
#define TIME_H

#include <stl_config.h>        // bool
#include <sys/time.h>          // struct timeval

class Time : public timeval
{
public:
  Time & update() { gettimeofday(this, NULL); return *this; }
  long getSeconds()               { return tv_sec;  }
  long getMicroSeconds()          { return tv_usec; }
  void setSeconds(long sec)       { tv_sec  = sec;  }
  void setMicroSeconds(long usec) { tv_usec = usec; }
};

Time operator+(const Time &, const Time &);
Time operator+(const Time &, const double);
Time operator+(const double, const Time &);

Time operator-(const Time &, Time &);
Time operator-(const Time &, const double);
Time operator-(const double, const Time &);

bool operator<(const Time &, const Time &);
bool operator<(const Time &, const double);
bool operator<(const double, const Time &);

bool operator>(const Time &, const Time &);
bool operator>(const Time &, const double);
bool operator>(const double, const Time &);

bool operator<=(const Time &, const Time &);
bool operator<=(const Time &, const double);
bool operator<=(const double, const Time &);

bool operator>=(const Time &, const Time &);
bool operator>=(const Time &, const double);
bool operator>=(const double, const Time &);

bool operator==(const Time &, const Time &);
bool operator==(const Time &, const double);
bool operator==(const double, const Time &);

#endif
