#include "system.h"
#include "socket.h"
#include "internetaddress.h"
#include "timedthread.h"
#include "breakdetector.h"



using namespace RTPAudio;

int main(int argc, char** argv)
{
   // ====== Initialize socket ==============================================
   Socket sock(Socket::IP,Socket::TCP);
   sock.setSoReuseAddress(true);
   sock.setTCPNoDelay(true);
   InternetAddress adr("ipv6-odin:1234");
   cout << adr << endl;
   InternetFlow flow = sock.allocFlow(adr);
   cout << flow << endl;
   if(sock.connect(flow,0x2e) == false) {
      puts("flow connect error!");
      if(sock.connect(adr,0x2e) == false) {
         puts("IPv4 connect OK!");
         exit(0);
      }
   }

   const char* text = "Das ist ein Test...";
   sock.write(text,strlen(text) + 1);

   /*
    int sd = sock.getSystemSocketDescriptor();
    char buf[1024];
      for(int i = 0;i < 1024;i++) {
         buf[i] = 0x00;
      }

      socklen_t len = 1024;
      int ok = getsockopt(sd,IPPROTO_IPV6,IPV6_PKTOPTIONS,&buf,&len);
      if(ok == -1) {
         perror("Fehler: ");
      }
      else {
        printf("ok=%d   l=%d\n",ok,len);

        msghdr* msg = (msghdr*)&buf;
        for(cmsghdr* c = CMSG_FIRSTHDR(msg);c;c = CMSG_NXTHDR(msg,c)) {
           printf("level=%d\n",c->cmsg_level);
        }

      }
  */

   char buffer[1024];
   ssize_t i = sock.read((char*)&buffer,1024);
   if(i > 0) {
      cout << "MSG> " << buffer << endl;
      const char* text2 = "Nachricht angekommen!";
      sock.write(text2,strlen(text2) + 1);
   }
   else {
      cout << "ERROR!" << endl;
   }
}
