#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <linux/sockios.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/signal.h>
#include <sys/uio.h>
#include <sys/poll.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>  

#include <netinet/in.h>
#include <arpa/inet.h>
#include <asm/bitops.h>
#include <linux/in6.h>
#include <linux/ipv6.h>
#include <linux/icmpv6.h>


// ###### Main program ######################################################
int main(int argc, char** argv)
{
   struct sockaddr_in6 sa;
   struct sockaddr_in6 source;
   int sd;
char outpack[1024];
struct icmp6hdr* icmph = (struct icmp6hdr*)outpack;
int q,y;
size_t len;
int csum_offset, sz_opt;
int err;
struct hostent* h;

   sa.sin6_family = AF_INET6;
   sa.sin6_port   = htons(IPPROTO_ICMPV6);
   sa.sin6_flowinfo = 0;
   sa.sin6_addr.s6_addr16[0] = htons(0x3ffe);
   sa.sin6_addr.s6_addr16[1] = htons(0x0815);
   sa.sin6_addr.s6_addr16[2] = htons(0x4711);
   sa.sin6_addr.s6_addr16[3] = htons(0x0000);
   sa.sin6_addr.s6_addr16[4] = htons(0x0000);
   sa.sin6_addr.s6_addr16[5] = htons(0x0000);
   sa.sin6_addr.s6_addr16[6] = htons(0x0000);
   sa.sin6_addr.s6_addr16[7] = htons(0x0115);


   
   h = gethostbyaddr((char*)&sa.sin6_addr.s6_addr16[0],16,AF_INET6);
   if(h != NULL) {
      printf("NAME=%s\n",h->h_name);
   }
   else perror("BAD NAME: ");


   sd = socket(AF_INET6,SOCK_RAW,IPPROTO_ICMPV6);
   if(sd < 0) {
      puts("ERROR: socket()");
      exit(1);
   }

	csum_offset = 2;
	sz_opt = sizeof(int);

	err = setsockopt(sd, SOL_RAW, IPV6_CHECKSUM, &csum_offset, sz_opt);
	if (err < 0)
	{
		perror("setsockopt(RAW_CHECKSUM)");
		exit(1);
	}


   source.sin6_family = AF_INET6;
   source.sin6_port   = htons(IPPROTO_ICMPV6);
   source.sin6_flowinfo = 0;
   source.sin6_addr.s6_addr32[0] = 0;
   source.sin6_addr.s6_addr32[1] = 0;
   source.sin6_addr.s6_addr32[2] = 0;
   source.sin6_addr.s6_addr32[3] = 0;
   if(bind(sd,(struct sockaddr*)&source,sizeof(struct sockaddr_in6)) != 0) {
      puts("ERROR: bind()");
      exit(1);
   }


icmph->icmp6_type = ICMPV6_ECHO_REQUEST;
icmph->icmp6_code = 0;
icmph->icmp6_cksum = 0;
icmph->icmp6_sequence = random() & 0xffff;
icmph->icmp6_identifier = random() & 0xffff;
len = sizeof(struct icmp6hdr);
printf("L=%d\n",len);

for(q = 0;q < 8;q++) {
   printf("A=%04x\n",ntohs(sa.sin6_addr.s6_addr16[q]));
}
printf("F=%x\n",ntohl(sa.sin6_flowinfo));
printf("P=%d\n",ntohs(sa.sin6_port));


q = 0;
y = sendto(sd,(void*)icmph,sizeof(struct icmp6hdr),0,
               (struct sockaddr*)&sa,sizeof(struct sockaddr_in6));
printf("=> %d\n",y);

}
